/***************************************************************************
                          kturing.cpp  -  description
                             -------------------
    begin                : lun dic 2 2002
    copyright            : (C) 2002 by Beniamino Galvani
    email                : ben_gal@libero.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <kaboutapplication.h>
#include <kpopupmenu.h>
#include <kapp.h>
#include <kstddirs.h>
#include <klocale.h>
#include <kmenubar.h>
#include <kaboutdata.h>
#include <kiconloader.h>
#include <kwin.h>
#include <kaboutapplication.h>
#include <kaboutkde.h>
#include <kpopupmenu.h>
#include <kurl.h>
#include <kfiledialog.h>
#include <kmessagebox.h>
#include <kio/netaccess.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qtable.h>
#include <qlineedit.h>
#include <ktempfile.h>
#include <qlcdnumber.h>
#include <qregexp.h>
#include <qdialog.h>
#include <qtextedit.h>
#include <qspinbox.h>

#include "kturing.h"



KTuring::KTuring(QWidget *parent, const char *name) : KMainWindow(parent,name)
{
  window = new KTuringWnd(this,"window");
  setCentralWidget(window);

  iLoader = new KIconLoader("kturing");

  fileMenu = new KPopupMenu();
  fileMenu->insertItem(iLoader->loadIcon("filenew",KIcon::Small),i18n("&New"), this, SLOT(fileNew()));
  fileMenu->insertItem(iLoader->loadIcon("fileopen",KIcon::Small),i18n("&Open"), this, SLOT(fileOpen()));
  fileMenu->insertItem(iLoader->loadIcon("filesave",KIcon::Small),i18n("&Save"), this , SLOT(fileSave()));
  //fileMenu->insertItem(iLoader->loadIcon("filesaveas",KIcon::MainToolbar),i18n("&Save as"), kapp , SLOT(closeAllWindows()));
  fileMenu->insertItem(iLoader->loadIcon("exit",KIcon::Small),i18n("&Exit"), kapp ,SLOT(closeAllWindows()));

  editMenu = new KPopupMenu();
  editMenu->insertItem(i18n("View &tape"), this, SLOT(viewTape()));
  editMenu->insertSeparator();
  editMenu->insertItem(i18n("&View program comment"), this, SLOT(viewComment()));
  editMenu->insertItem(i18n("&Edit program comment"), this, SLOT(editComment()));
  editMenu->insertSeparator();
  editMenu->insertItem(i18n("&Clear state table"), this, SLOT(clearTable()));
  editMenu->insertItem(i18n("&Add 5 rows"), this, SLOT(addTableRows()));
  editMenu->insertSeparator();
  editMenu->insertItem(i18n("&Set step delay"), this, SLOT(setStepDelay()));

  help = helpMenu(QString::null,FALSE);

  menuBar()->insertItem(i18n("&File"), fileMenu);
  menuBar()->insertItem(i18n("&Edit"), editMenu);
  menuBar()->insertItem( i18n("&Help"), help );


  resize(QSize(780,300));
}

KTuring::~KTuring()
{
}


void KTuring::fileNew(){

  window->machine->reset();
  setCaption("");
  clearTable();
  window->tapeEdit->setText("");
  window->stateLcd->display(1);
  window->updateText();
  url.setFileName("");

}
void KTuring::fileOpen(){

  bool initComment;

  KURL openurl=KFileDialog::getOpenURL(QString::null,
        i18n("*.ktur *.tur|Supported files (*.ktur *.tur)"), this, i18n("Open File..."));
  if(!openurl.isEmpty())
    {
      QString tmpfile;
      if(!(KIO::NetAccess::download( openurl, tmpfile ))){
        KMessageBox::error(this,i18n("File not found"),i18n("Error"));
      }

     QFile file(tmpfile);
     if ( ! file.open(IO_ReadOnly) ){
        KMessageBox::error(this,i18n("Cannot open the file"),i18n("Error"));
     }
     QTextStream ts( &file );
     QString string;
     QString field;
     int n=0;

     fileNew();

     initComment = true;
     comment = "";

     while ( !ts.eof() ) {
        string = ts.readLine();                    // excluding '\n'
        if (string.at(0) == '#'){
          comment = comment + string.mid(1) + "\n";
          continue;
        }
        if (string.at(0) == ' ')                    //comment
          continue;
        if (string.isEmpty())
          continue;

        initComment = false;

        if(string.startsWith("tape")){
          field = string.simplifyWhiteSpace();
          field = field.mid(5);
          window->tapeEdit->setText(field);
          continue;
        }

        string = string.simplifyWhiteSpace();

        field = string.section(' ',0,0);
        window->stateTable->setText(n,0,field);
        field = string.section(' ',1,1);
        window->stateTable->setText(n,1,field);
        field = string.section(' ',2,2);
        window->stateTable->setText(n,2,field);
        field = string.section(' ',3,3);
        window->stateTable->setText(n,3,field);
        field = string.section(' ',4,4);
        window->stateTable->setText(n,4,field);

        n++;
     }
     file.close();
     KIO::NetAccess::removeTempFile(tmpfile);
     url = openurl;
     setCaption(url.fileName());
    }
}
void KTuring::fileSave(){

  int r=0;

  KURL saveurl=KFileDialog::getSaveURL(QString::null,
        i18n("*.ktur"), this, i18n("Save as..."));

  if(saveurl.isEmpty())
    return;

  KTempFile tmpfile(locateLocal("tmp", "kturing"));
  QFile file(tmpfile.name());
  if ( ! file.open(IO_WriteOnly) ){
      KMessageBox::error(this,i18n("Cannot open the temp file"),i18n("Error"));
  }
  QTextStream ts( &file );

  QString tempComm = comment;
  tempComm = tempComm.replace(QRegExp("\n"),"\n#");
  ts << "#" << tempComm << endl << endl;

  while(1){
    bool inv_row = false;

    for(int c=0; c < 5; c++){
      if(!window->stateTable->text(r,c))
        inv_row = true;
    }

    if(inv_row)
      break;

    ts << window->stateTable->item(r,0)->text().toInt() << " ";
    ts << window->stateTable->item(r,1)->text().at(0) << " ";
    ts << window->stateTable->item(r,2)->text().at(0) << " ";
    ts << window->stateTable->item(r,3)->text().at(0) << " ";
    ts << window->stateTable->item(r,4)->text().toInt() << " ";

    ts << endl;
    r++;
  }

  ts << endl;
  ts << "tape " << window->tapeEdit->text();
  ts << endl;
  file.close();

  if(KIO::NetAccess::exists(saveurl)){

    QString msg = i18n("Overwrite existing file ") + saveurl.url() + " ?";

    if( KMessageBox::questionYesNo(this,msg,
                               i18n("Confirm")) == 4){
        tmpfile.unlink();
        return;
    }
  }

  KIO::NetAccess::upload(tmpfile.name(),saveurl);

  tmpfile.unlink();
}

void KTuring::clearTable(){
  for(int r=0; r < window->stateTable->numRows(); r++)
    for(int c=0; c < 5; c++)
      window->stateTable->clearCell(r,c);
}


void KTuring::viewTape(){
  KMessageBox::information(this,window->machine->getTape(),i18n("Machine tape"));
}

void KTuring::viewComment(){
  KMessageBox::information(this,comment,i18n("Program Comment"));
}

void KTuring::editComment(){
  cdialog = new CommentDialog();
  cdialog->textEdit->setText(comment);

  cdialog->exec();

  if (cdialog->result() == QDialog::Accepted){
    comment = cdialog->textEdit->text();
  }

  delete cdialog;

}

void KTuring::addTableRows(){
  window->stateTable->setNumRows(window->stateTable->numRows() + 5);
}

void KTuring::setStepDelay(){
  DelayDialog *ddialog = new DelayDialog();

  ddialog->spinBox->setValue(window->delay);

  ddialog->exec();

  if (ddialog->result() == QDialog::Accepted){
  window->delay = ddialog->spinBox->value();
  if (window->delay < 10)
    window->delay = 10;
  }

  delete ddialog;
}
