/***************************************************************************
                          kturing.h  -  description
                             -------------------
    begin                : lun dic 2 2002
    copyright            : (C) 2002 by Beniamino Galvani
    email                : ben_gal@libero.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KTURING_H
#define KTURING_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kapp.h>
#include <qwidget.h>
#include <kmainwindow.h>
#include <kpopupmenu.h>
#include <kurl.h>

#include "kturingwnd.h"
#include "commentdialog.h"
#include "delaydialog.h"


/** KTuring is the base class of the project */
class KTuring : public KMainWindow
{
  Q_OBJECT
  public:
    /** construtor */
    KTuring(QWidget* parent=0, const char *name=0);
    /** destructor */
    ~KTuring();

  public slots:
    void fileNew();
    void fileOpen();
    void fileSave();
    void viewTape();
    void clearTable();
    void viewComment();
    void editComment();
    void addTableRows();
    void setStepDelay();

  private:
    KTuringWnd *window;
    KIconLoader *iLoader;
    KPopupMenu *fileMenu;
    KPopupMenu *editMenu;
    KPopupMenu *help;
    KURL url;
    QString comment;
    CommentDialog *cdialog;
};

#endif
