/***************************************************************************
                          kturingwnd.h  -  description
                             -------------------
    begin                : lun dic 2 2002
    copyright            : (C) 2002 by Beniamino Galvani
    email                : ben_gal@libero.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KTURINGWND_H
#define KTURINGWND_H

#include "kturingui.h"
#include <qcanvas.h>
#include <qfontmetrics.h>
#include <qtimer.h>

#include "machine.h"

/**
  *@author Beniamino Galvani
  */

class KTuringWnd : public KTuringUi  {
  Q_OBJECT
public:
	KTuringWnd(QWidget *parent, const char *name);
	~KTuringWnd();

  Machine *machine;
  int delay;

 void updateText();

public slots:
  void load();
  void step();
  void stop();
  void go();
  void tapeLeft();
  void tapeRight();

private:
  QCanvas *canvas;
  QCanvasText *text;
  QCanvasRectangle *rect;

  QFont *font;
  QFontMetrics *metrix;
  int textOffset;
  QTimer *timer;

};

#endif
