/***************************************************************************
                          machine.cpp  -  description
                             -------------------
    begin                : lun dic 2 2002
    copyright            : (C) 2002 by Beniamino Galvani
    email                : ben_gal@libero.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/



#include "machine.h"

Machine::Machine(){
  cstate = 1;
  cpos = 0;
  end = TRUE;
  tape = "";
}
Machine::~Machine(){
}

void Machine::reset(){
  cstate = 1;
  cpos = 0;
  end = TRUE;
  tape = "";
}

void Machine::addState(state *s){

  list.append(*s);
  end = FALSE;

}

void Machine::setTape(QString str){

  tape = str;

}


void Machine::doStep(){

  QValueList<state>::iterator it;
  int fl=0;

  for( it = list.begin(); it != list.end() && fl == 0; it++ ){
    if(((*it).s == cstate) && ((*it).c == tape.at(cpos))){
      tape.at(cpos) = (*it).nc;
      cstate = (*it).ns;
      cpos += ((*it).dir ? 1 : -1);

      if(cpos < 0){
        tape = "_" + tape;
        cpos++;
      }
      if(cpos >= tape.length())
        tape += "_";
      fl = 1;
    }
  }
  if (fl == 0)
    end = TRUE;

}

QString Machine::getTape(){
  return tape;
}

int Machine::getCpos(){
  return cpos;
}

bool Machine::finished(){
  return end;
}

int Machine::getCstate(){
  return cstate;
}

