/***************************************************************************
                          machine.h  -  description
                             -------------------
    begin                : lun dic 2 2002
    copyright            : (C) 2002 by Beniamino Galvani
    email                : ben_gal@libero.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MACHINE_H
#define MACHINE_H

#include <qstring.h>
#include <qvaluelist.h>


/**
  *@author Beniamino Galvani
  */

typedef struct{
  int s;
  QChar c;
  int ns;
  QChar nc;
  bool dir;   // 1= ->  & 0 = <-
} state;


class Machine {
private:
  QString tape;
  QValueList<state> list;
  int cstate;
  int cpos;
  bool end;

public:
	Machine();
	~Machine();
  void addState(state *);
  void setTape(QString);
  void doStep();
  QString getTape();
  int getCpos();
  int getCstate();
  bool finished();
  void reset();

};

#endif
